searchNodes=[{"doc":"A sharp EventStoreDB 20+ client backed by mintStreamsSpear uses the term stream across different contexts. There are four possible contexts for the term stream in Spear:HTTP2 streams of datagRPC stream requests, responses, and bidirectional communicationEventStoreDB streams of eventsElixir StreamsDescriptions of each are given in the Streams guide.ConnectionsSpear needs a connection to interact with an EventStoreDB. Spear provides the Spear.Connection GenServer for this purpose. Connections are referred to as &quot;conn&quot; in the documentation.Like an Ecto.Repo, it can be handy to have a module which itself represents a connection to an EventStoreDB. For this, Spear provides Spear.Client which allows one to call any function in Spear without the conn argument on the client module.defmodule MyApp.MyClient do use Spear.Client, otp_app: :my_app end iex&gt; MyApp.MyClient.start_link(connection_string: &quot;esdb://localhost:2113&quot;) iex&gt; MyApp.MyClient.stream!(&quot;my_stream&quot;) |&gt; Enum.to_list() [ %Spear.Event{}, %Spear.Event{}, .. ]See the Spear.Client module for more information.Record interfacesThe Spear.Records.* modules provide macro interfaces for matching and creating messages sent and received from the EventStoreDB. These are mostly intended for internal uses such as the mapping between a Spear.Records.Streams.read_resp/0 and a Spear.Event.t/0, but they can also be used to extract values from any raw response records (e.g. those returned from functions where the raw?: true option is passed).iex&gt; import Spear.Records.Streams, only: [read_resp: 0, read_resp: 1] iex&gt; event = Spear.stream!(conn, &quot;my_stream&quot;, raw?: true) |&gt; Enum.take(1) |&gt; List.first() {:&quot;event_store.client.streams.ReadResp&quot;, {checkpoint, ..}} iex&gt; match?(read_resp(), event) true iex&gt; match?(read_resp(content: {:checkpoint, _}), event) trueMacros in these modules are generated with Record.defrecord/2 with the contents extracted from the protobuf messages (indirectly via :gpb).","ref":"Spear.html","title":"Spear","type":"module"},{"doc":"Appends an enumeration of events to an EventStoreDB streamevent_stream is an enumerable which may either be a collection of Spear.Event.t/0 structs or more low-level Spear.Records.Streams.append_resp/0 records. In cases where the enumerable produces Spear.Event.t/0 structs, they will be lazily mapped to AppendReq records before being encoded to wire data.See the Writing Events guide for more information about writing events.Options:expect - (default: :any) the expectation to set on the status of the stream. The write will fail if the expectation fails. See Spear.ExpectationViolation for more information about expectations.:timeout - (default: 5_000 - 5s) the GenServer timeout for calling the RPC.:raw? - (default: false) a boolean which controls whether the return signature should be a simple :ok | {:error, any()} or {:ok, AppendResp.t()} | {:error, any()}. This can be used to extract metadata and information from the append response which is not available through the simplified return API, such as the stream's revision number after writing the events.:credentials - (default: nil) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details.Examplesiex&gt; [Spear.Event.new(&quot;es_supported_clients&quot;, %{})] ...&gt; |&gt; Spear.append(conn, expect: :exists) :ok iex&gt; [Spear.Event.new(&quot;es_supported_clients&quot;, %{})] ...&gt; |&gt; Spear.append(conn, expect: :empty) {:error, %Spear.ExpectationViolation{current: 1, expected: :empty}}","ref":"Spear.html#append/4","title":"Spear.append/4","type":"function"},{"doc":"Cancels a subscriptionThis function will cancel a subscription if the provided subscription_reference exists, but is idempotent: if the subscription_reference is not an active subscription reference, :ok will be returned.Subscriptions are automatically cancelled when a subscribe process exits.Examplesiex&gt; {:ok, subscription} = Spear.subscribe(conn, self(), &quot;my_stream&quot;) {:ok, #Reference&lt;0.4293953740.2750676995.30541&gt;} iex&gt; Spear.cancel_subscription(conn, subscription) :ok iex&gt; Spear.cancel_subscription(conn, subscription) :ok","ref":"Spear.html#cancel_subscription/3","title":"Spear.cancel_subscription/3","type":"function"},{"doc":"Changes a user's password by providing the current passwordThis can be accomplished regardless of the current credentials since the user's current password is provided.OptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;changeit&quot;, [&quot;$ops&quot;]) :ok iex&gt; Spear.change_user_password(conn, &quot;aladdin&quot;, &quot;changeit&quot;, &quot;open sesame&quot;) :ok","ref":"Spear.html#change_user_password/5","title":"Spear.change_user_password/5","type":"function"},{"doc":"Creates an EventStoreDB userOptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$ops&quot;], credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok","ref":"Spear.html#create_user/6","title":"Spear.create_user/6","type":"function"},{"doc":"Deletes an EventStoreDB streamEventStoreDB supports two kinds of stream deletions: soft-deletes and tombstones. By default this function will perform a soft-delete. Pass the tombstone?: true option to tombstone the stream.Soft-deletes make the events in the specified stream no longer accessible through reads. A scavenge operation will reclaim the disk space taken by any soft-deleted events. New events may be written to a soft-deleted stream. When reading soft-deleted streams, :from options of :start and :end will behave as expected, but all events in the stream will have revision numbers off-set by the number of deleted events.Tombstoned streams may not be written to ever again. Attempting to write to a tombstoned stream will fail with a gRPC :failed_precondition erroriex&gt; [Spear.Event.new(&quot;delete_test&quot;, %{})] |&gt; Spear.append(conn, &quot;delete_test_0&quot;) :ok iex&gt; Spear.delete_stream(conn, &quot;delete_test_0&quot;, tombstone?: true) :ok iex&gt; [Spear.Event.new(&quot;delete_test&quot;, %{})] |&gt; Spear.append(conn, &quot;delete_test_0&quot;) {:error, %Spear.Grpc.Response{ data: &quot;&quot;, message: &quot;Event stream &#39;delete_test_0&#39; is deleted.&quot;, status: :failed_precondition, status_code: 9 }}Options:tombstone? - (default: false) controls whether the stream is soft-deleted or tombstoned.:timeout - (default: 5_000 - 5s) the time allowed to block while waiting for the EventStoreDB to delete the stream.:expect - (default: :any) the expected state of the stream when performing the deleteion. See append/4 and Spear.ExpectationViolation for more information.:credentials - (default: nil) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details.Examplesiex&gt; Spear.append(events, conn, &quot;my_stream&quot;) :ok iex&gt; Spear.delete_stream(conn, &quot;my_stream&quot;) :ok iex&gt; Spear.stream!(conn, &quot;my_stream&quot;) |&gt; Enum.to_list() []","ref":"Spear.html#delete_stream/3","title":"Spear.delete_stream/3","type":"function"},{"doc":"Deletes a user from the EventStoreDBEventStoreDB users are deleted by the login_name parameter as passed to Spear.create_user/6.OptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$ops&quot;], credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok iex&gt; Spear.delete_user(conn, &quot;aladdin&quot;, credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok","ref":"Spear.html#delete_user/3","title":"Spear.delete_user/3","type":"function"},{"doc":"Disables a user's ability to make requests against the EventStoreDBThis can be used in conjunction with Spear.enable_user/3 to temporarily deny access to a user as an alternative to deleting and creating the user. Enabling and disabling users does not require the password of the user: just that requestor to be in the $admins group.OptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.enable_user(conn, &quot;aladdin&quot;) :ok iex&gt; Spear.disable_user(conn, &quot;aladdin&quot;) :ok","ref":"Spear.html#disable_user/3","title":"Spear.disable_user/3","type":"function"},{"doc":"Enables a user to make requests against the EventStoreDBDisabling and enabling users are an alternative to repeatedly creating and deleting users and is suitable for when a user needs to be temporarily denied access.OptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.disable_user(conn, &quot;aladdin&quot;) :ok iex&gt; Spear.enable_user(conn, &quot;aladdin&quot;) :ok","ref":"Spear.html#enable_user/3","title":"Spear.enable_user/3","type":"function"},{"doc":"Queries the metadata for a streamNote that the stream argument is passed through meta_stream/1 before being read. It is not necessary to call that function on the stream name before passing it as stream.If no metadata has been set on a stream {:error, :unset} is returned.OptionsUnder the hood, get_stream_metadata/3 uses read_stream/3 and all options are passed directly to that function. These options are overridden, however, and cannot be changed::direction:from:max_count:raw?Examplesiex&gt; Spear.get_stream_metadata(conn, &quot;my_stream&quot;) {:error, :unset} iex&gt; Spear.get_stream_metadata(conn, &quot;some_stream_with_max_count&quot;) {:ok, %Spear.StreamMetadata{max_count: 50_000, ..}}","ref":"Spear.html#get_stream_metadata/3","title":"Spear.get_stream_metadata/3","type":"function"},{"doc":"Determines the metadata stream for any given streamMeta streams are used by the EventStoreDB to store some internal information about a stream, and to configure features such setting time-to-lives for events or streams.Examplesiex&gt; Spear.meta_stream(&quot;es_supported_clients&quot;) &quot;$$es_supported_clients&quot;","ref":"Spear.html#meta_stream/1","title":"Spear.meta_stream/1","type":"function"},{"doc":"Parses an EventStoreDB timestamp into a DateTime.t() in UTC time.Examplesiex&gt; Spear.parse_stamp(16187636458580612) {:ok, ~U[2021-04-18 16:34:05.858061Z]}","ref":"Spear.html#parse_stamp/1","title":"Spear.parse_stamp/1","type":"function"},{"doc":"Pings a connectionThis can be used to ensure that the connection process is alive, or to roughly measure the latency between the connection process and EventStoreDB.Examplesiex&gt; Spear.ping(conn) :pong","ref":"Spear.html#ping/2","title":"Spear.ping/2","type":"function"},{"doc":"Reads a chunk of events from an EventStoreDB stream into an enumerableUnlike stream!/3, this function will only read one chunk of events at a time specified by the :max_count option. This function also does not raise in cases of error, instead returning an ok- or error-tuple.If the stream_name EventStoreDB stream does not exist (is empty) and the gRPC request succeeds for this function, {:ok, []} will be returned.Options:from - (default: :start) the EventStoreDB stream revision from which to read. Valid values include :start, :end, any non-negative integer representing the event number revision in the stream and events. Event numbers are exclusive (e.g. reading from 0 will first return the event numbered 0 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events (either Spear.Event or ReadResp records) can also be supplied and will be treated as exclusive.:direction - (default: :forwards) the direction in which to read the EventStoreDB stream. Valid values include :forwards and :backwards. Reading the EventStoreDB stream forwards will return events in the order in which they were written to the EventStoreDB; reading backwards will return events in the opposite order.:resolve_links? - (default: true) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution.:max_count - (default: 42) the maximum number of events to read from the EventStoreDB stream. Any positive integer is valid. Even if the stream is longer than this :max_count option, only :max_count events will be returned from this function. :infinity is not a valid value for :max_count. Use stream!/3 for an enumerable which reads an EventStoreDB stream in its entirety in chunked network requests.:timeout - (default: 5_000 - 5s) the time allowed for the read of the single chunk of events in the EventStoreDB stream. Note that the gRPC request which reads events from the EventStoreDB is front-loaded in this function: the :timeout covers the time it takes to read the events. The timeout may be exceeded:raw?: - (default: false) controls whether or not the enumerable event_stream is decoded to Spear.Event structs from their raw ReadReq output. Setting raw?: true prevents this transformation and leaves each event as a ReadReq record. See Spear.Event.from_read_response/2 for more information.:credentials - (default: nil) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details.Timing and TimeoutsThe gRPC request which reads events from the EventStoreDB is front-loaded in this function: this function returns immediately after receiving all data off the wire from the network request. This means that the :timeout option covers the gRPC request and response time but not any time spend decoding the response (see the Enumeration Characteristics section below for more details on how the enumerable decodes messages).The default timeout of 5s may not be enough time in cases of either reading very large numbers of events or reading events with very large bodies.Note that up to the :max_count of events is returned from this call depending on however many events are in the EventStoreDB stream being read. When tuning the :timeout option, make sure to test against a stream which is at least as long as :max_count events.Enumeration CharacteristicsThe event_stream Enumerable.t/0 returned in the success case of this function is a wrapper around the bytes received from the gRPC response. Note that when the {:ok, event_stream} is returned, the gRPC request has already concluded.This offers only marginal performance improvement: an enumerable is returned mostly for consistency in the Spear API.Examples# say we have 5 events in the stream &quot;es_supported_clients&quot; iex&gt; {:ok, events} = Spear.read_stream(conn, &quot;es_supported_clients&quot;, max_count: 2) iex&gt; events |&gt; Enum.count() 2 iex&gt; {:ok, events} = Spear.read_stream(conn, &quot;es_supported_clients&quot;, max_count: 10) iex&gt; events |&gt; Enum.count() 5 iex&gt; events |&gt; Enum.take(1) [ %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot;, metadata: %{..}, type: &quot;grpc-client&quot; } ]","ref":"Spear.html#read_stream/3","title":"Spear.read_stream/3","type":"function"},{"doc":"Performs a generic request synchronouslyThis is appropriate for many operations across the Users, Streams, and Operations APIs but not suitable for Spear.subscribe/4 or the Persistent Subscriptions API.message must be an enumeration of records as created by the Record Interfaces. Lazy stream enumerations are allowed and are not run until each element is serialized over the wire.This function is mostly used under-the-hood to implement functions in Spear such as Spear.create_user/5, but may be used generically.Options:timeout - (default: 5_000ms - 5s) the GenServer timeout: the maximum time allowed to wait for this request to complete.:credentials - (default: nil) the username and password to use to make the request. Overrides the connection-level credentials if provided. Connection-level credentials are used as the default if not provided.Examplesiex&gt; alias Spear.Records.Users iex&gt; require Users iex&gt; message = Users.enable_req(options: Users.enable_req_options(login_name: &quot;my_user&quot;)) iex&gt; Spear.request(conn, Users, :Enable, [message], credentials: {&quot;admin&quot;, &quot;changeit&quot;}) {:ok, Users.enable_resp()}","ref":"Spear.html#request/5","title":"Spear.request/5","type":"function"},{"doc":"Resets a user's passwordThis can be only requested by a user in the $admins group. The current password is not passed in this request, so this function is suitable for setting a new password when the current password is lost.OptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;changeit&quot;, [&quot;$ops&quot;]) :ok iex&gt; Spear.reset_user_password(conn, &quot;aladdin&quot;, &quot;open sesame&quot;, credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok","ref":"Spear.html#reset_user_password/4","title":"Spear.reset_user_password/4","type":"function"},{"doc":"Sets the global stream ACLThis function appends an event to the $streams EventStoreDB stream detailing how the EventStoreDB should allow access to user and system streams (with the user_acl and system_acl arguments, respectively).See the security guide for more information.Options:json_encode! - (default: Jason.encode!/1) a 1-arity JSON encoding function used to serialize the event. This event must be JSON encoded in order for the EventStoreDB to consider it valid.Remaining options are passed to Spear.append/4. The :expect option will be applied to the $streams system stream, so one could attempt to set the initial ACL by passing expect: :empty.ExamplesThis recreates the default ACL:iex&gt; Spear.set_global_acl(conn, Spear.Acl.allow_all(), Spear.Acl.admins_only()) :ok","ref":"Spear.html#set_global_acl/4","title":"Spear.set_global_acl/4","type":"function"},{"doc":"Sets a stream's metadataNote that the stream argument is passed through meta_stream/1 before being read. It is not necessary to call that function on the stream name before passing it as stream.OptionsThis function uses append/4 under the hood. All options are passed to the opts argument of append/4.Examples# only allow admins to read, write, and delete the stream (or stream metadata) iex&gt; metadata = %Spear.StreamMetadata{acl: Spear.Acl.admins_only()} iex&gt; Spear.set_stream_metadata(conn, stream, metadata) :ok","ref":"Spear.html#set_stream_metadata/4","title":"Spear.set_stream_metadata/4","type":"function"},{"doc":"Collects an EventStoreDB stream into an enumerableThis function may raise in cases where the gRPC requests fail to read events from the EventStoreDB (in cases of timeout or unavailability).This function does not raise if a stream does not exist (is empty), instead returning an empty enumerable [].connection may be any valid GenServer name (including PIDs) for a process running the Spear.Connection GenServer.stream_name can be any stream, existing or not, including projected streams such as category streams or event-type streams. The :all atom may be passed as stream_name to read all events in the EventStoreDB.Options:from - (default: :start) the EventStoreDB stream revision from which to read. Valid values include :start, :end, any non-negative integer representing the event number revision in the stream and events. Event numbers are exclusive (e.g. reading from 0 will first return the event numbered 1 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events (either Spear.Event or ReadResp records) can also be supplied and will be treated as exclusive.:direction - (default: :forwards) the direction in which to read the EventStoreDB stream. Valid values include :forwards and :backwards. Reading the EventStoreDB stream forwards will return events in the order in which they were written to the EventStoreDB; reading backwards will return events in the opposite order.:resolve_links? - (default: true) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution.:chunk_size - (default: 128) the number of events to read from the EventStoreDB at a time. Any positive integer is valid. See the enumeration characteristics section below for more information about how :chunk_size works and how to tune it.:timeout - (default: 5_000 - 5s) the time allowed for the read of a single chunk of events in the EventStoreDB stream. This time is not cumulative: an EventStoreDB stream 100 events long which takes 5s to read each chunk may be read in chunks of 20 events culumaltively in 25s. A timeout of 5_001ms would not raise a timeout error in that scenario (assuming the chunk read consistently takes &lt;= 5_000 ms).:raw?: - (default: false) controls whether or not the enumerable event_stream is decoded to Spear.Event structs from their raw ReadReq output. Setting raw?: true prevents this transformation and leaves each event as a ReadReq record. See Spear.Event.from_read_response/2 for more information.:credentials - (default: nil) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details.Enumeration CharacteristicsThe event_stream Enumerable.t/0 returned by this function initially contains a buffer of bytes from the first read of the stream stream_name. This buffer potentially contains up to :chunk_size messages when run. The enumerable is written as a formula which abstracts away the chunking nature of the gRPC requests, however, so even though the EventStoreDB stream is read in chunks (per the :chunk_size option), the entire EventStoreDB stream can be read by running the enumeration (e.g. with Enum.to_list/1). Note that the stream will make a gRPC request to read more events whenever the buffer runs dry with up to :chunk_size messages filling the buffer on each request.:chunk_size is difficult to tune as it causes a tradeoff between (gRPC) request duration and number of messages added to the buffer. A higher :chunk_size may hydrate the buffer with more events and reduce the number of gRPC requests needed to read an entire stream, but it also increases the number of messages that will be sent over the network per request which could decrease reliability. Generally speaking, a lower :chunk_size is appropriate for streams in which the events are large and a higher :chunk_size is appropriate for streams with many small events. Manual tuning and trial-and-error can be used to find a performant :chunk_size setting for any individual environment.Examplesiex&gt; Spear.stream!(MyConnection, &quot;es_supported_clients&quot;, chunk_size: 1) |&gt; Enum.take(1) [ %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot;, metadata: %{..}, type: &quot;grpc-client&quot; } ] # say we have 5 events in the &quot;es_supported_clients&quot; stream iex&gt; Spear.stream!(MyConnection, &quot;es_supported_clients&quot;, chunk_size: 3) |&gt; Enum.count() 5","ref":"Spear.html#stream!/3","title":"Spear.stream!/3","type":"function"},{"doc":"Subscribes a process to an EventStoreDB streamUnlike read_stream/3 or stream!/3, this function does not return an enumerable. Instead the subscriber process is signed up to receive messages for subscription events. Events are emitted in order as info messages with the signatureSpear.Event.t() | Spear.Filter.Checkpoint.t()or if the raw?: true option is provided, Spear.Records.Streams.read_resp/0 records will be returned.This function will block the caller until the subscription has been confirmed by the EventStoreDB.When the subscription is terminated, the subscription process will receive a message in the form of {:eos, reason}. {:eos, :closed} is currently the only implemented end-of-stream reason and it occurs when the connection is severed between Spear and the EventStoreDB. If this message is received, the subscription is considered to be concluded and the subscription process must re-subscribe from the last received event or checkpoint to resume the subscription.Options:from - (default: :start) the EventStoreDB stream revision from which to read. Valid values include :start, :end, any non-negative integer representing the event number revision in the stream and events. Event numbers are exclusive (e.g. reading from 0 will first return the event numbered 1 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events and checkpoints (Spear.Event.t/0, ReadResp records, or Spear.Filter.Checkpoint.t/0) can also be supplied and will be treated as exclusive.:filter - (default: nil) the server-side filter to apply. This option is only valid if the stream_name is :all. See Spear.Filter for more information.:resolve_links? - (default: true) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution.:timeout - (default: 5_000) the time to wait for the EventStoreDB to confirm the subscription request.:raw? - (default: false) controls whether the events are sent as raw ReadResp records or decoded into Spear.Event.t/0s:credentials - (default: nil) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details.Examples# say there are 3 events in the EventStoreDB stream &quot;my_stream&quot; iex&gt; {:ok, sub} = Spear.subscribe(conn, self(), &quot;my_stream&quot;, from: 0) {:ok, #Reference&lt;0.1160763861.3015180291.51238&gt;} iex&gt; flush %Spear.Event{} # second event %Spear.Event{} # third event :ok iex&gt; Spear.cancel_subscription(conn, sub) :ok iex&gt; {:ok, sub} = Spear.subscribe(conn, self(), :all, filter: Spear.Filter.exclude_system_events()) iex&gt; flush %Spear.Filter.Checkpoint{} %Spear.Filter.Checkpoint{} %Spear.Event{} %Spear.Event{} %Spear.Filter.Checkpoint{} %Spear.Event{} %Spear.Filter.Checkpoint{} :ok iex&gt; GenServer.call(conn, :close) {:ok, :closed} iex&gt; flush {:eos, :closed}","ref":"Spear.html#subscribe/4","title":"Spear.subscribe/4","type":"function"},{"doc":"Updates an existing EventStoreDB userOptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$ops&quot;], credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok iex&gt; Spear.update_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$admins&quot;], credentials: {&quot;admin&quot;, &quot;changeit&quot;}) :ok","ref":"Spear.html#update_user/6","title":"Spear.update_user/6","type":"function"},{"doc":"Fetches details about an EventStoreDB userOptionsAll options are passed to Spear.request/5.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$ops&quot;]) :ok iex&gt; Spear.user_details(conn, &quot;aladdin&quot;) {:ok, %Spear.User{ enabled?: true, full_name: &quot;Aladdin&quot;, groups: [&quot;$ops&quot;], last_updated: ~U[2021-04-18 16:48:38.583313Z], login_name: &quot;aladdin&quot; }}","ref":"Spear.html#user_details/3","title":"Spear.user_details/3","type":"function"},{"doc":"A macro for defining a module which represents a connection to an EventStoreDBLike an Ecto.Repo or an Extreme client, this macro allows you to call functions on the module representing the connection instead of passing the connection pid or name as an argument to functions in Spear. This can be useful for client connections central to a service. All callbacks provided by this module are implemented on clients created with use Spear.Client.This pattern can be useful for applications which depend on an EventStoreDB connection similar to applications which depend on a (e.g.) PostgreSQL connection via Ecto.Repo. Writing clients as modules provides an intuitive &quot;is-a&quot; interface (e.g. &quot;MyEventStoreClient is an EventStoreDB client&quot;). Since this module defines a complete behaviour for a client module, mocking calls to the EventStoreDB is easy via a test dependency like the wonderful Dashbit library Mox.If a service does not know which connections it may need until runtime, the functions in Spear may be used with a connection processes spawned via DynamicSupervisor.start_child/2 instead.ConfigurationThe __using__/1 macro defined by this module takes an optional :otp_app option. If provided, a helper clause for the start_link/1 callback will be injected which will fetch configuration for the connection from Application.get_env(otp_app, __MODULE__), if available.Otherwise configuration for the connection may be passed through arguments to start_link/1.Examplesdefmodule MyEventStoreClient do use Spear.Client, otp_app: :my_app end [MyEventStoreClient] |&gt; Supervisor.start_link(strategy: :one_for_one) iex&gt; MyEventStoreClient.stream!(:all) |&gt; Enum.take(1) [%Spear.Event{}]","ref":"Spear.Client.html","title":"Spear.Client","type":"behaviour"},{"doc":"A wrapper around Spear.append/3","ref":"Spear.Client.html#c:append/2","title":"Spear.Client.append/2","type":"callback"},{"doc":"A wrapper around Spear.append/4","ref":"Spear.Client.html#c:append/3","title":"Spear.Client.append/3","type":"callback"},{"doc":"A wrapper around Spear.cancel_subscription/2","ref":"Spear.Client.html#c:cancel_subscription/1","title":"Spear.Client.cancel_subscription/1","type":"callback"},{"doc":"A wrapper around Spear.cancel_subscription/3","ref":"Spear.Client.html#c:cancel_subscription/2","title":"Spear.Client.cancel_subscription/2","type":"callback"},{"doc":"A wrapper around Spear.change_user_password/4","ref":"Spear.Client.html#c:change_user_password/3","title":"Spear.Client.change_user_password/3","type":"callback"},{"doc":"A wrapper around Spear.change_user_password/5","ref":"Spear.Client.html#c:change_user_password/4","title":"Spear.Client.change_user_password/4","type":"callback"},{"doc":"A wrapper around Spear.create_user/5","ref":"Spear.Client.html#c:create_user/4","title":"Spear.Client.create_user/4","type":"callback"},{"doc":"A wrapper around Spear.create_user/6","ref":"Spear.Client.html#c:create_user/5","title":"Spear.Client.create_user/5","type":"callback"},{"doc":"A wrapper around Spear.delete_stream/2","ref":"Spear.Client.html#c:delete_stream/1","title":"Spear.Client.delete_stream/1","type":"callback"},{"doc":"A wrapper around Spear.delete_stream/3","ref":"Spear.Client.html#c:delete_stream/2","title":"Spear.Client.delete_stream/2","type":"callback"},{"doc":"A wrapper around Spear.delete_user/2","ref":"Spear.Client.html#c:delete_user/1","title":"Spear.Client.delete_user/1","type":"callback"},{"doc":"A wrapper around Spear.delete_user/3","ref":"Spear.Client.html#c:delete_user/2","title":"Spear.Client.delete_user/2","type":"callback"},{"doc":"A wrapper around Spear.disable_user/2","ref":"Spear.Client.html#c:disable_user/1","title":"Spear.Client.disable_user/1","type":"callback"},{"doc":"A wrapper around Spear.disable_user/3","ref":"Spear.Client.html#c:disable_user/2","title":"Spear.Client.disable_user/2","type":"callback"},{"doc":"A wrapper around Spear.enable_user/2","ref":"Spear.Client.html#c:enable_user/1","title":"Spear.Client.enable_user/1","type":"callback"},{"doc":"A wrapper around Spear.enable_user/3","ref":"Spear.Client.html#c:enable_user/2","title":"Spear.Client.enable_user/2","type":"callback"},{"doc":"A wrapper around Spear.get_stream_metadata/2","ref":"Spear.Client.html#c:get_stream_metadata/1","title":"Spear.Client.get_stream_metadata/1","type":"callback"},{"doc":"A wrapper around Spear.get_stream_metadata/3","ref":"Spear.Client.html#c:get_stream_metadata/2","title":"Spear.Client.get_stream_metadata/2","type":"callback"},{"doc":"A wrapper around Spear.ping/1","ref":"Spear.Client.html#c:ping/0","title":"Spear.Client.ping/0","type":"callback"},{"doc":"A wrapper around Spear.ping/2","ref":"Spear.Client.html#c:ping/1","title":"Spear.Client.ping/1","type":"callback"},{"doc":"A wrapper around Spear.read_stream/2","ref":"Spear.Client.html#c:read_stream/1","title":"Spear.Client.read_stream/1","type":"callback"},{"doc":"A wrapper around Spear.read_stream/3","ref":"Spear.Client.html#c:read_stream/2","title":"Spear.Client.read_stream/2","type":"callback"},{"doc":"A wrapper around Spear.reset_user_password/3","ref":"Spear.Client.html#c:reset_user_password/2","title":"Spear.Client.reset_user_password/2","type":"callback"},{"doc":"A wrapper around Spear.reset_user_password/4","ref":"Spear.Client.html#c:reset_user_password/3","title":"Spear.Client.reset_user_password/3","type":"callback"},{"doc":"A wrapper around Spear.set_global_acl/3","ref":"Spear.Client.html#c:set_global_acl/2","title":"Spear.Client.set_global_acl/2","type":"callback"},{"doc":"A wrapper around Spear.set_global_acl/4","ref":"Spear.Client.html#c:set_global_acl/3","title":"Spear.Client.set_global_acl/3","type":"callback"},{"doc":"A wrapper around Spear.set_stream_metadata/3","ref":"Spear.Client.html#c:set_stream_metadata/2","title":"Spear.Client.set_stream_metadata/2","type":"callback"},{"doc":"A wrapper around Spear.set_stream_metadata/4","ref":"Spear.Client.html#c:set_stream_metadata/3","title":"Spear.Client.set_stream_metadata/3","type":"callback"},{"doc":"Starts a client as part of a supervision tree.This function is defaulted to pull connection parameters from application config or from the argsExamples# lib/my_app/application.ex [ {MyEventStoreClient, connection_string: &quot;esdb://localhost:2113&quot;}, .. ] |&gt; Supervisor.start_link(strategy: :one_for_one)","ref":"Spear.Client.html#c:start_link/1","title":"Spear.Client.start_link/1","type":"callback"},{"doc":"A wrapper around Spear.stream!/2","ref":"Spear.Client.html#c:stream!/1","title":"Spear.Client.stream!/1","type":"callback"},{"doc":"A wrapper around Spear.stream!/3","ref":"Spear.Client.html#c:stream!/2","title":"Spear.Client.stream!/2","type":"callback"},{"doc":"A wrapper around Spear.subscribe/3","ref":"Spear.Client.html#c:subscribe/2","title":"Spear.Client.subscribe/2","type":"callback"},{"doc":"A wrapper around Spear.subscribe/4","ref":"Spear.Client.html#c:subscribe/3","title":"Spear.Client.subscribe/3","type":"callback"},{"doc":"A wrapper around Spear.update_user/5","ref":"Spear.Client.html#c:update_user/4","title":"Spear.Client.update_user/4","type":"callback"},{"doc":"A wrapper around Spear.update_user/6","ref":"Spear.Client.html#c:update_user/5","title":"Spear.Client.update_user/5","type":"callback"},{"doc":"A wrapper around Spear.user_details/3","ref":"Spear.Client.html#c:user_details/1","title":"Spear.Client.user_details/1","type":"callback"},{"doc":"A wrapper around Spear.user_details/3","ref":"Spear.Client.html#c:user_details/2","title":"Spear.Client.user_details/2","type":"callback"},{"doc":"A GenServer which brokers a connection to an EventStoreDBSpear.Connection will attempt to connect immediately after GenServer init. Failures to connect will result in back-off retries in segments of 500ms. Any GenServer to a connection process may return {:error, :closed} if the connection process is alive but the HTTP2 connection to the EventStoreDB is not yet (re)established. Spear.Connection will automatically attempt to re-connect to the EventStoreDB if the connection is severed.Spear.Connection processes accept GenServer.call/3s of :close to force a disconnect from an EventStoreDB and a subsequent GenServer.cast/2 of :connect to reconnect based on the configuration supplied at init-time.If configuration parameters must change between disconnects and reconnects, spawning and killing connections with a DynamicSupervisor is recommended.Spear.Connection will attempt to connect immediately after GenServer init. Failures to connect will result in back-off retries in segments of 500ms. Any GenServer to a connection process may return {:error, :closed} if the connection process is alive but the HTTP2 connection to the EventStoreDB is not yet (re)established. Spear.Connection will automatically attempt to re-connect to the EventStoreDB if the connection is severed.Spear.Connection processes accept GenServer.call/3s of :close to force a disconnect from an EventStoreDB and a subsequent GenServer.cast/2 of :connect to reconnect based on the configuration supplied at init-time.If configuration parameters must change between disconnects and reconnects, spawning and killing connections with a DynamicSupervisor is recommended.ConfigurationSee the Spear.Connection.Configuration module for available configuration of connections.TLS/SSL configuration and credentialsSee the Security guide for information about certificates, credentials, and access control lists (ACLs).Keep-aliveSpear and the EventStoreDB use gRPC keep-alive to ensure that any hung connections are noticed and restarted.EventStoreDB has its own configuration for keep-alive and each Spear client's configuration should not necessarily match the server configuration. With a :keep_alive_interval too low on the Spear-side and with very many connected clients, the keep-alive pings can effectively become a DDoS even while no clients perform any operations. This does not necessarily apply to the keep-alive settings in EventStoreDB: a client connects to a single EventStoreDB but an EventStoreDB may have hundreds or more clients connected at once.:keep_alive_interval does not express an interval in the way of :timer.send_interval/3. Instead the keep-alive timer is optimized to reset upon any data received from the connection.This means that (assuming consistent network, which is generous) either the Spear client or EventStoreDB server will dominate the keep-alive ping communication, the driver of the conversation being which ever has the lowest keep-alive interval configured. For this reason, it is generally advisable to set the client keep-alive just higher than the server keep-alive, adding noise for network latency, since the client's keep-alive routine will only trigger when the server's keep-alive message is behind schedule.Note that there may not be much value in attempting to optimize the keep-alive settings unless the network is very unstable: keep-alive only has utility when the client, server, or network is seriously delayed or silently severed.Examplesiex&gt; {:ok, conn} = Spear.Connection.start_link(connection_string: &quot;esdb://localhost:2113&quot;) iex&gt; Spear.stream!(conn, &quot;es_supported_clients&quot;) |&gt; Enum.take(3) [%Spear.Event{}, %Spear.Event{}, %Spear.Event{}]","ref":"Spear.Connection.html","title":"Spear.Connection","type":"module"},{"doc":"","ref":"Spear.Connection.html#fetch_subscription/2","title":"Spear.Connection.fetch_subscription/2","type":"function"},{"doc":"Starts a connection processThis function can be called directly in order to link it to the current process, but the more common workflow is to start a Spear.Connection GenServer as a part of a supervision tree.ExamplesE.g. in an application's supervision tree defined in lib/my_app/application.ex:children = [ {Spear.Connection, name: MyConnection, connection_string: &quot;esdb://localhost:2113&quot;} ] Supervisor.start_link(children, strategy: :one_for_one)","ref":"Spear.Connection.html#start_link/1","title":"Spear.Connection.start_link/1","type":"function"},{"doc":"A connection processA connection process (either referred to as conn or connection in the documentation) may either be a PID or a name such as a module or otherwise atom.Examplesiex&gt; {:ok, conn} = Spear.Connection.start_link(connection_string: &quot;esdb://localhost:2113&quot;) {:ok, #PID&lt;0.225.0&gt;} iex&gt; Spear.read_stream(conn, &quot;es_supported_clients&quot;, max_count: 1) {:ok, #Stream&lt;[ enum: #Function&lt;62.80860365/2 in Stream.unfold/2&gt;, funs: [#Function&lt;48.80860365/1 in Stream.map/2&gt;] ]&gt;}","ref":"Spear.Connection.html#t:t/0","title":"Spear.Connection.t/0","type":"type"},{"doc":"A server-side filter to apply when reading events from an EventStoreDBRegular expressionsElixir's built-in Regex module and Kernel.sigil_r/2 use PCRE-compatible regular expressions, but from the EventStoreDB codebase it seems that at time of writing, filtering is done with C-sharp's System.Text.RegularExpressions built-in. C-sharp regular expressions diverge in syntax a bit from PCRE-compatible expressions, so mileage may vary when passing Elixir regular expressions.As an escape hatch, you may build a Spear.Filter.t/0 manually and use a String.t/0 as the :by field. This value will be untouched except for last-minute encoding to go over-the-wire to the server.%Spear.Filter{ on: :stream_name, by: &quot;&lt;some-complicated-regex&gt;&quot;, checkpoint_after: 1024 }If possible, the list of prefixes should be used as the :by option as they are unambiguous.CheckpointsThe EventStoreDB will emit checkpoint events to a subscriber regularly.This prevents a possible (and perhaps probable) scenario wherethe EventStoreDB contains many eventsthe client is searching for a small number of events relative to the size of :all(and/or) the target events are sparsely spread throughout :allUnder these conditions, the EventStoreDB may progress through :all quite a ways before finding an event. If the connection is severed between the client and server while the EventStoreDB is part-way through a large drought of targeted events, the server will need to re-seek through the drought when the client re-connects and passes an old :from option to Spear.subscribe/4.These checkpoints will arrive in the mailbox of the subscriber process as Spear.Filter.Checkpoint.t/0 structs and may be used as a restore point by passing them to the :from option of Spear.subscribe/4.For example, say we have a subscriber process which is a GenServer and some function save_checkpoint/1 which saves checkpoint information durably (to disk or a database for example). It will handle subscription events in its GenServer.handle_info/2 callback.defmodule MySubscriber do use GenServer alias Spear.{Event, Filter.Checkpoint} .. @impl GenServer def handle_info(%Event{} = event, state) do # .. handle the event event |&gt; Event.to_checkpoint() |&gt; save_checkpoint() {:noreply, state} end def handle_info(%Checkpoint{} = checkpoint, state) do save_checkpoint(checkpoint) {:noreply, state} end endCheckpoint IntervalThe EventStoreDB will send a checkpoint after filtering a configurable number of events. The :checkpoint_after field can be used to configure this behavior. Note that the :checkpoint_after is only allowed by the server to be a multiple of 32. Other values will be rounded to the nearest multiple.The default is set at 1024 (32 * 32) in Spear but this is tunable per filter with checkpoint_after/2, or by manually adjusting the :checkpoint_after field in this struct.","ref":"Spear.Filter.html","title":"Spear.Filter","type":"module"},{"doc":"Sets the checkpoint intervalExamplesiex&gt; import Spear.Filter iex&gt; checkpoint_after(~f/^[^\\$].*/rs, 32 * 8) %Spear.Filter{by: ~r/^[^\\$].*/, checkpoint_after: 256, on: :stream_name}","ref":"Spear.Filter.html#checkpoint_after/2","title":"Spear.Filter.checkpoint_after/2","type":"function"},{"doc":"Produces a filter which excludes system eventsThis is a potentially common filter for subscribers reading from :all.The sigil_f/2 version is~f/^[^\\$].*/rsExamplesiex&gt; Spear.Filter.exclude_system_events() %Spear.Filter{by: ~r/^[^\\$].*/, checkpoint_after: 1024, on: :stream_name}","ref":"Spear.Filter.html#exclude_system_events/0","title":"Spear.Filter.exclude_system_events/0","type":"function"},{"doc":"A sigil defining a filter, without escapingWorks the same as sigil_f/2 but does not allow interpolation or escape sequences.Examplesiex&gt; import Spear.Filter iex&gt; ~F/^[^\\$].*/rs %Spear.Filter{by: ~r/^[^\\$].*/, checkpoint_after: 1024, on: :stream_name}","ref":"Spear.Filter.html#sigil_F/2","title":"Spear.Filter.sigil_F/2","type":"function"},{"doc":"A sigil defining short-hand notation for writing filtersFilters may either filter on EventStoreDB stream name or event type and may either filter by a regular expression or a list of prefix strings.ModifiersThis f sigil supports the following modifiers. (Note that modifiers are the suffix of the sigil. E.g. the i in ~r/hello/i is a modifier for the regex sigil that declares that the match is case-insensitive.)For the choice between stream-name and event-type filtering:s - filter on the stream namet - filter on the event typeFor the choice between prefixes and regular expressions:p - filter by a list of prefixes. If this option is passed the sigil body will be interpreted as a white-space separated list of prefixes similar to sigil_w/2 from the standard libraryr - filter using a regular expressionExamplesiex&gt; import Spear.Filter iex&gt; ~f/My.Aggregate.A- My.Aggregate.B-/ps %Spear.Filter{ by: [&quot;My.Aggregate.A-&quot;, &quot;My.Aggregate.B-&quot;], checkpoint_after: 1024, on: :stream_name } iex&gt; ~f/^[^\\$].*/rs %Spear.Filter{by: ~r/^[^\\$].*/, checkpoint_after: 1024, on: :stream_name}","ref":"Spear.Filter.html#sigil_f/2","title":"Spear.Filter.sigil_f/2","type":"function"},{"doc":"A filter which can be applied to a subscription to trigger server-side result filteringThis filter type is intended to be passed as the :filter option to Spear.subscribe/4.Examplesiex&gt; import Spear.Filter iex&gt; ~f/^[^\\$].*/rs # exclude system events which start with &quot;$&quot; %Spear.Filter{by: ~r/^[^\\$].*/, checkpoint_after: 1024, on: :stream_name}","ref":"Spear.Filter.html#t:t/0","title":"Spear.Filter.t/0","type":"type"},{"doc":"A struct representing an access control list (ACL)See the Security guide for more information on ACLs","ref":"Spear.Acl.html","title":"Spear.Acl","type":"module"},{"doc":"Produces an ACL that only allows access to all resources to the $admins groupExamplesiex&gt; Spear.Acl.admins_only() %Spear.Acl{ delete: &quot;$admins&quot;, metadata_read: &quot;$admins&quot;, metadata_write: &quot;$admins&quot;, read: &quot;$admins&quot;, write: &quot;$admins&quot; }","ref":"Spear.Acl.html#admins_only/0","title":"Spear.Acl.admins_only/0","type":"function"},{"doc":"Produces an ACL that allows all users access to all resourcesNote that clients that do not provide credentials at all fall under the $all group.Examplesiex&gt; Spear.Acl.allow_all() %Spear.Acl{ delete: &quot;$all&quot;, metadata_read: &quot;$all&quot;, metadata_write: &quot;$all&quot;, read: &quot;$all&quot;, write: &quot;$all&quot; }","ref":"Spear.Acl.html#allow_all/0","title":"Spear.Acl.allow_all/0","type":"function"},{"doc":"Converts an ACL struct to a map with the keys expected by the EventStoreDBThis function is used internall by Spear.set_global_acl/4 to create a global ACL event body, but may be used to create an acl body on its own.Examplesiex&gt; Spear.Acl.allow_all() |&gt; Spear.Acl.to_map() %{ &quot;$w&quot; =&gt; &quot;$all&quot;, &quot;$r&quot; =&gt; &quot;$all&quot;, &quot;$d&quot; =&gt; &quot;$all&quot;, &quot;$mw&quot; =&gt; &quot;$all&quot;, &quot;$mr&quot; =&gt; &quot;$all&quot; }","ref":"Spear.Acl.html#to_map/1","title":"Spear.Acl.to_map/1","type":"function"},{"doc":"An access control list (ACL) typeSee the Security guide for more information on ACLsACLs may provide permissions for a single user/group or a list of user/groups.Examplesiex&gt; Spear.Acl.allow_all() %Spear.Acl{ delete: &quot;$all&quot;, metadata_read: &quot;$all&quot;, metadata_write: &quot;$all&quot;, read: &quot;$all&quot;, write: &quot;$all&quot; }","ref":"Spear.Acl.html#t:t/0","title":"Spear.Acl.t/0","type":"type"},{"doc":"Configuration for Spear.ConnectionsOptions:name - the name of the GenServer. See GenServer.name/0 for more information. When not provided, the spawned process is not aliased to a name and is only addressable through its PID.:connection_string - the connection string to parse containing all connection information. Other options like :host or :port will be parsed from the connection string. If options parsed from the connection string are passed, they will be treated as overrides to the value found in the connection string. Consult the EventStoreDB documentation for formulating a valid connection string.:mint_opts - (default: [protocols: [:http2], mode: :active]) a keyword list of options to pass to mint. The default values cannot be overridden. This can be useful for configuring TLS. See the security guide for more information.:host - (default: &quot;localhost&quot;) the host address of the EventStoreDB:port - (default: 2113) the external gRPC port of the EventStoreDB:tls? - (default: false) whether or not to use TLS to secure the connection to the EventStoreDB:username - (default: &quot;admin&quot;) the user to connect as:password - (default: &quot;changeit&quot;) the user's password:keep_alive_interval - (default: 10_000ms - 10s) the period to send keep-alive pings to the EventStoreDB. Set -1 to disable keep-alive checks. Should be any integer value &gt;= 10_000. This option can be used in conjunction with :keep_alive_timeout to properly disconnect if the EventStoreDB is not responding to network traffic.:keep_alive_timeout - (default: 10_000ms - 10s) the time after sending a keep-alive ping when the ping will be considered unacknowledged. Used in conjunction with :keep_alive_interval. Set to -1 to disable keep-alive checks. Should be any integer value &gt;= 10_000.See the Spear.Connection module docs for more information about keep-alive.","ref":"Spear.Connection.Configuration.html","title":"Spear.Connection.Configuration","type":"module"},{"doc":"Parses configuration from a keyword listThis function is used internally by Spear.Connection when connecting.","ref":"Spear.Connection.Configuration.html#new/1","title":"Spear.Connection.Configuration.new/1","type":"function"},{"doc":"Configuration for a Spear.Connection.","ref":"Spear.Connection.Configuration.html#t:t/0","title":"Spear.Connection.Configuration.t/0","type":"type"},{"doc":"A simplified event structThis event struct is easier to work with than the protobuf definitions for AppendReq and ReadResp records","ref":"Spear.Event.html","title":"Spear.Event","type":"module"},{"doc":"Converts a read-response message to a Spear.EventThis function is applied by Stream.map/2 onto streams returned by reading operations such as Spear.stream!/3, Spear.read_stream/3, etc. by default. This can be turned off by passing the raw?: true opt to a reading function.This function follows links. For example, if an read event belongs to a projected stream such as an event type stream, this function will give the event body of the source event, not the link. Forcing the return of the link body can be accomplished with the :link? option set to true (it is false by default).Options:link? - (default: false) forces returning the body of the link event for events read from projected streams. Has no effect on events from non- projected streams.:json_decoder - (default: Jason.decode!/2) a 2-arity function to use for events with a &quot;content-type&quot; of &quot;application/json&quot;.All remaining options passed as opts other than :link? and :json_decoder are passed to the second argument of the :json_decoder 2-arity function.JSON decodingEvent bodies are commonly written to the EventStoreDB in JSON format as the format is a human-readable and supported in nearly any language. Events carry a small piece of metadata in the ReadResp.ReadEvent.RecordedEvent's :metadata map field which declares the content-type of the event body: &quot;content-type&quot;. This function will automatically attempt to decode any events which declare an &quot;application/json&quot; content-type as JSON using the :json_decoder 2-arity function option. Other content-types will not trigger any automatic behavior.Spear takes an optional dependency on the Jason library as it is currently the most popular JSON (en/de)coding library. If you add this project to the deps/0 in a mix.exs file and wish to take advantage of the automatic JSON decoding functionality, you may also need to include :jason. As an optional dependency, :jason is not included in your dependencies just by dependending on :spear.# mix.exs def deps do [ {:spear, &quot;&gt;= 0.0.0&quot;}, {:jason, &quot;&gt;= 0.0.0&quot;}, .. ] endOther JSON (en/de)coding libraries may be swapped in, such as with Poisoniex&gt; Spear.stream!(conn, &quot;es_supported_clients&quot;, raw?: true) ...&gt; |&gt; Stream.map(&amp;Spear.Event.from_read_response(&amp;1, decoder: &amp;Poison.decode!/2, keys: :atoms))ExamplesSpear.stream!(conn, &quot;es_supported_clients&quot;, raw?: true) |&gt; Stream.map(&amp;Spear.Event.from_read_response/1) |&gt; Enum.to_list() # =&gt; [%Spear.Event{}, %Spear.Event{}, ..]","ref":"Spear.Event.html#from_read_response/2","title":"Spear.Event.from_read_response/2","type":"function"},{"doc":"Creates an event structThis function does not append the event to a stream on its own, but can provide events to Spear.append/4 which will append events to a stream.type is any string used to declare how the event is typed. This is very arbitrary and may coincide with struct names or may be hard-coded per event.Options:id - (default: Spear.Event.uuid_v4()) the event's ID. See the section on event IDs below.:content_type - (default: &quot;application/json&quot;) the encoding used to turn the event's body into binary data. If the content-type is &quot;application/json&quot;, the EventStoreDB and Spear (in Spear.Event.from_read_response/2):custom_metadata - (default: &quot;&quot;) an event field outside of the body meant as a bag for storing custom attributes about an event. Usage of this field is not obligatory: leaving it blank is perfectly normal.Event IDsEventStoreDB uses event IDs to provide an idempotency feature. Any event written to the EventStoreDB with an already existing ID will be not be duplicated.iex&gt; event = Spear.Event.new(&quot;grpc-client&quot;, %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}) %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;1e654b2a-ff04-4af8-887f-052442edcd83&quot;, metadata: %{content_type: &quot;application/json&quot;, custom_metadata: &quot;&quot;}, type: &quot;grpc-client&quot; } iex&gt; [event] |&gt; Spear.append(conn, &quot;idempotency_test&quot;) :ok iex&gt; [event] |&gt; Spear.append(conn, &quot;idempotency_test&quot;) :ok iex&gt; Spear.stream!(conn, &quot;idempotency_test&quot;) |&gt; Enum.to_list() [ %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;1e654b2a-ff04-4af8-887f-052442edcd83&quot;, metadata: %{ commit_position: 18446744073709551615, content_type: &quot;application/json&quot;, created: ~U[2021-04-07 21:53:40.395681Z], custom_metadata: &quot;&quot;, prepare_position: 18446744073709551615, stream_name: &quot;idempotency_test&quot;, stream_revision: 0 }, type: &quot;grpc-client&quot; } ]ExamplesFile.stream!(&quot;data.csv&quot;) |&gt; MyCsvParser.parse_stream() |&gt; Stream.map(fn [id, type, amount] -&gt; Spear.Event.new(&quot;ChargeDeclared&quot;, %{id: id, type: type, amount: amount} ) end) |&gt; Spear.append(conn, &quot;ChargesFromCsvs&quot;, batch_size: 20)","ref":"Spear.Event.html#new/3","title":"Spear.Event.new/3","type":"function"},{"doc":"Converts an event into a checkpointThis is useful when storing stream position in Spear.subscribe/4 subscriptions.","ref":"Spear.Event.html#to_checkpoint/1","title":"Spear.Event.to_checkpoint/1","type":"function"},{"doc":"Converts a Spear.Event into an append-request struct which proposes a new messageNote that each event must be individually structured as an AppendReq message in order to be written to an EventStoreDB. The RPC definition for writing events specifies a stream input, though, so all AppendReq events passed to Spear.append/4 will be batched into a single write operation.rpc Append (stream AppendReq) returns (AppendResp);These messages are serialized to wire data before being sent to the EventStoreDB when using Spear.append/4 to write events via protobuf encoding.encoder_mapping is a mapping of content-types to 1-arity encode functions. The default is%{&quot;application/json&quot; =&gt; &amp;Jason.encode!/1}The Spear.Event.t/0's .metadata.content_type value will be searched in this map. If an encoder is found for that content-type, the event body will be encoded with the encoding function. If no encoder is found, the event body will be passed as-is.To set up an encoder for something like Erlang term format, an encoding map like the following could be used%{&quot;application/vnd.erlang-term-format&quot; =&gt; &amp;:erlang.term_to_binary/1}In order to disable JSON encoding, pass an empty map %{} as the encoder_mappingExamplesiex&gt; events [%Spear.Event{}, %Spear.Event{}, ..] iex&gt; events |&gt; Enum.map(&amp;Spear.Event.to_proposed_message/1) [%EventStore.Client.Streams.AppendReq{}, ..]","ref":"Spear.Event.html#to_proposed_message/2","title":"Spear.Event.to_proposed_message/2","type":"function"},{"doc":"Produces a random UUID v4 in human-readable formatExamplesiex&gt; Spear.Event.uuid_v4 &quot;98d3a5e2-ceb4-4a78-8084-97edf9452823&quot; iex&gt; Spear.Event.uuid_v4 &quot;2629ea4b-d165-45c9-8a2f-92b5e20b894e&quot;","ref":"Spear.Event.html#uuid_v4/0","title":"Spear.Event.uuid_v4/0","type":"function"},{"doc":"Produces a consistent UUID v4 in human-readable format given any input data structureThis function can be used to generate a consistent UUID for a data structure of any shape. Under the hood it uses :erlang.phash2/1 to hash the data structure, which should be portable across many environments.This function can be taken advantage of to generate consistent event IDs for the sake of idempotency (see the Event ID section in new/3 for more information). Pass the :id option to new/3 to override the default random UUID generation.Examplesiex&gt; Spear.Event.uuid_v4 %{&quot;foo&quot; =&gt; &quot;bar&quot;} &quot;33323639-3934-4339-b332-363939343339&quot; iex&gt; Spear.Event.uuid_v4 %{&quot;foo&quot; =&gt; &quot;bar&quot;} &quot;33323639-3934-4339-b332-363939343339&quot;","ref":"Spear.Event.html#uuid_v4/1","title":"Spear.Event.uuid_v4/1","type":"function"},{"doc":"A struct representing an EventStoreDB eventSpear.Event.t/0s may be created to write to the EventStoreDB with new/3. Spear.Event.t/0s will be lazily mapped into gRPC-compatible structs before being written to the EventStoreDB with to_proposed_message/2.Spear.Event.t/0s typically look different between events which are written to- and events which are read from the EventStoreDB. Read events contain more metadata which pertains to EventStoreDB specifics like the creation timestamp of the event.Examplesiex&gt; Spear.stream!(conn, &quot;es_supported_clients&quot;) |&gt; Enum.take(1) [ %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot;, metadata: %{ commit_position: 18446744073709551615, content_type: &quot;application/json&quot;, created: ~U[2021-04-01 21:11:38.196799Z], custom_metadata: &quot;&quot;, prepare_position: 18446744073709551615, stream_name: &quot;es_supported_clients&quot;, stream_revision: 0 }, type: &quot;grpc-client&quot; } ] iex&gt; Spear.Event.new(&quot;grpc-client&quot;, %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, %Spear.Event{ body: %{&quot;languages&quot; =&gt; [&quot;typescript&quot;, &quot;javascript&quot;], &quot;runtime&quot; =&gt; &quot;NodeJS&quot;}, id: &quot;b952575a-1014-404d-ba20-f0904df7954e&quot;, metadata: %{content_type: &quot;application/json&quot;, custom_metadata: &quot;&quot;}, type: &quot;grpc-client&quot; }","ref":"Spear.Event.html#t:t/0","title":"Spear.Event.t/0","type":"type"},{"doc":"A structure representing how an append request's expectations were violatedExpectationsA client may exert expectations on write requests which will fail the request if violated. Any of these values may be passed to the :expect option of Spear.append/4::any - (default) any stream. Cannot be violated.:exists - the EventStoreDB stream must exist prior to the proposed events being written:empty - the EventStoreDB stream must not exist prior to the proposed events being writtenrevision - any positive integer representing the current size of the stream. The head of the EventStoreDB stream must match this revision number in order for the append request to succeed.If an expectation is violated, the return signature will be {:error, %Spear.ExpectationViolation{}}, which gives information about the expectation and the current revision. See t/0.Expectations may also be set in Spear.delete_stream/3, although if expectations set on a deletion request are violated, EventStoreDB returns a gRPC error response instead of this struct.","ref":"Spear.ExpectationViolation.html","title":"Spear.ExpectationViolation","type":"module"},{"doc":"A structure representing how an append request's expectations were violatedThis struct is returned on calls to Spear.append/4 which set an expectation on the current stream revision with the :expect option.:current is not the number of events in the EventStoreDB stream but rather the current event revision. If three events are appended to an empty stream, the :current will be 2. Note that deletions do not reset a stream's revision number.Examples# say EventStoreDB stream &quot;stream_that_should_be_empty&quot; has 6 events iex&gt; Spear.append(events, conn, &quot;stream_that_should_be_empty&quot;, expect: :empty) {:error, %Spear.ExpectationViolation{current: 5, expected: :empty}} # say EventStoreDB stream &quot;stream_that_should_have_events&quot; has no events iex&gt; Spear.append(events, conn, &quot;stream_that_should_have_events&quot;, expect: :exists) {:error, %Spear.ExpectationViolation{current: :empty, expected: :exists}}","ref":"Spear.ExpectationViolation.html#t:t/0","title":"Spear.ExpectationViolation.t/0","type":"type"},{"doc":"A struct representing a checkpoint in server-side filtering","ref":"Spear.Filter.Checkpoint.html","title":"Spear.Filter.Checkpoint","type":"module"},{"doc":"A struct representing a checkpoint in a server-side filter operationWhen subscribing to the :all stream, one may provide a :filter option which the server will use to filter events before sending them over the network.Since the results of a server-side filtering subscription can be sparsely spread out in the entire :all stream, the EventStoreDB emits checkpoints as it reads through the events.A client can restore its position in a filter subscription by passing one of these structs to the :from option of Spear.subscribe/4.See the Spear.Filter documentation for more information.","ref":"Spear.Filter.Checkpoint.html#t:t/0","title":"Spear.Filter.Checkpoint.t/0","type":"type"},{"doc":"A struct for describing the metadata about a stream","ref":"Spear.StreamMetadata.html","title":"Spear.StreamMetadata","type":"module"},{"doc":"Converts a stream metadata struct to a map in the format EventStoreDB expects","ref":"Spear.StreamMetadata.html#to_map/1","title":"Spear.StreamMetadata.to_map/1","type":"function"},{"doc":"Internal and custom metadata about a streamSee the EventStoreDB stream metadata documentation for more details.","ref":"Spear.StreamMetadata.html#t:t/0","title":"Spear.StreamMetadata.t/0","type":"type"},{"doc":"A struct representing an EventStoreDB userThese are returned from Spear.user_details/3.","ref":"Spear.User.html","title":"Spear.User","type":"module"},{"doc":"","ref":"Spear.User.html#from_details_resp/1","title":"Spear.User.from_details_resp/1","type":"function"},{"doc":"A struct representing an EventStoreDB userThe :enabled? flag controls whether or not a user may execute requests, even with valid login information. This can be used to temporarily disable a user as an alternative to deleting the user altogether.Examplesiex&gt; Spear.create_user(conn, &quot;Aladdin&quot;, &quot;aladdin&quot;, &quot;open sesame&quot;, [&quot;$ops&quot;]) :ok iex&gt; Spear.user_details(conn, &quot;aladdin&quot;) {:ok, %Spear.User{ enabled?: true, full_name: &quot;Aladdin&quot;, groups: [&quot;$ops&quot;], last_updated: ~U[2021-04-18 16:48:38.583313Z], login_name: &quot;aladdin&quot; }}","ref":"Spear.User.html#t:t/0","title":"Spear.User.t/0","type":"type"},{"doc":"A record macro interface for interacting with the EventStoreDB Operations API","ref":"Spear.Records.Operations.html","title":"Spear.Records.Operations","type":"module"},{"doc":"","ref":"Spear.Records.Operations.html#scavenge_resp/1","title":"Spear.Records.Operations.scavenge_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#scavenge_resp/2","title":"Spear.Records.Operations.scavenge_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Operations.html#service/0","title":"Spear.Records.Operations.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Operations.html#service_module/0","title":"Spear.Records.Operations.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Operations.html#set_node_priority_req/1","title":"Spear.Records.Operations.set_node_priority_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#set_node_priority_req/2","title":"Spear.Records.Operations.set_node_priority_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req/1","title":"Spear.Records.Operations.start_scavenge_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req/2","title":"Spear.Records.Operations.start_scavenge_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req_options/1","title":"Spear.Records.Operations.start_scavenge_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req_options/2","title":"Spear.Records.Operations.start_scavenge_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req/1","title":"Spear.Records.Operations.stop_scavenge_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req/2","title":"Spear.Records.Operations.stop_scavenge_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req_options/1","title":"Spear.Records.Operations.stop_scavenge_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req_options/2","title":"Spear.Records.Operations.stop_scavenge_req_options/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Persistent Subscriptions API","ref":"Spear.Records.Persistent.html","title":"Spear.Records.Persistent","type":"module"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req/1","title":"Spear.Records.Persistent.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req/2","title":"Spear.Records.Persistent.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_options/1","title":"Spear.Records.Persistent.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_options/2","title":"Spear.Records.Persistent.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_settings/1","title":"Spear.Records.Persistent.create_req_settings/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_settings/2","title":"Spear.Records.Persistent.create_req_settings/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_resp/1","title":"Spear.Records.Persistent.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_resp/2","title":"Spear.Records.Persistent.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req/1","title":"Spear.Records.Persistent.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req/2","title":"Spear.Records.Persistent.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req_options/1","title":"Spear.Records.Persistent.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req_options/2","title":"Spear.Records.Persistent.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_resp/1","title":"Spear.Records.Persistent.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_resp/2","title":"Spear.Records.Persistent.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req/1","title":"Spear.Records.Persistent.read_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req/2","title":"Spear.Records.Persistent.read_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_ack/1","title":"Spear.Records.Persistent.read_req_ack/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_ack/2","title":"Spear.Records.Persistent.read_req_ack/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_nack/1","title":"Spear.Records.Persistent.read_req_nack/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_nack/2","title":"Spear.Records.Persistent.read_req_nack/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options/1","title":"Spear.Records.Persistent.read_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options/2","title":"Spear.Records.Persistent.read_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options_uuid_option/1","title":"Spear.Records.Persistent.read_req_options_uuid_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options_uuid_option/2","title":"Spear.Records.Persistent.read_req_options_uuid_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp/1","title":"Spear.Records.Persistent.read_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp/2","title":"Spear.Records.Persistent.read_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event/1","title":"Spear.Records.Persistent.read_resp_read_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event/2","title":"Spear.Records.Persistent.read_resp_read_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event_recorded_event/1","title":"Spear.Records.Persistent.read_resp_read_event_recorded_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event_recorded_event/2","title":"Spear.Records.Persistent.read_resp_read_event_recorded_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_subscription_confirmation/1","title":"Spear.Records.Persistent.read_resp_subscription_confirmation/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_subscription_confirmation/2","title":"Spear.Records.Persistent.read_resp_subscription_confirmation/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Persistent.html#service/0","title":"Spear.Records.Persistent.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Persistent.html#service_module/0","title":"Spear.Records.Persistent.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req/1","title":"Spear.Records.Persistent.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req/2","title":"Spear.Records.Persistent.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_options/1","title":"Spear.Records.Persistent.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_options/2","title":"Spear.Records.Persistent.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_settings/1","title":"Spear.Records.Persistent.update_req_settings/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_settings/2","title":"Spear.Records.Persistent.update_req_settings/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_resp/1","title":"Spear.Records.Persistent.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_resp/2","title":"Spear.Records.Persistent.update_resp/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Projections API","ref":"Spear.Records.Projections.html","title":"Spear.Records.Projections","type":"module"},{"doc":"","ref":"Spear.Records.Projections.html#create_req/1","title":"Spear.Records.Projections.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req/2","title":"Spear.Records.Projections.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options/1","title":"Spear.Records.Projections.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options/2","title":"Spear.Records.Projections.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_continuous/1","title":"Spear.Records.Projections.create_req_options_continuous/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_continuous/2","title":"Spear.Records.Projections.create_req_options_continuous/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_transient/1","title":"Spear.Records.Projections.create_req_options_transient/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_transient/2","title":"Spear.Records.Projections.create_req_options_transient/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_resp/1","title":"Spear.Records.Projections.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_resp/2","title":"Spear.Records.Projections.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req/1","title":"Spear.Records.Projections.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req/2","title":"Spear.Records.Projections.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req_options/1","title":"Spear.Records.Projections.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req_options/2","title":"Spear.Records.Projections.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_resp/1","title":"Spear.Records.Projections.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_resp/2","title":"Spear.Records.Projections.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req/1","title":"Spear.Records.Projections.disable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req/2","title":"Spear.Records.Projections.disable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req_options/1","title":"Spear.Records.Projections.disable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req_options/2","title":"Spear.Records.Projections.disable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_resp/1","title":"Spear.Records.Projections.disable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_resp/2","title":"Spear.Records.Projections.disable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req/1","title":"Spear.Records.Projections.enable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req/2","title":"Spear.Records.Projections.enable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req_options/1","title":"Spear.Records.Projections.enable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req_options/2","title":"Spear.Records.Projections.enable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_resp/1","title":"Spear.Records.Projections.enable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_resp/2","title":"Spear.Records.Projections.enable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req/1","title":"Spear.Records.Projections.reset_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req/2","title":"Spear.Records.Projections.reset_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req_options/1","title":"Spear.Records.Projections.reset_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req_options/2","title":"Spear.Records.Projections.reset_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_resp/1","title":"Spear.Records.Projections.reset_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_resp/2","title":"Spear.Records.Projections.reset_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req/1","title":"Spear.Records.Projections.result_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req/2","title":"Spear.Records.Projections.result_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req_options/1","title":"Spear.Records.Projections.result_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req_options/2","title":"Spear.Records.Projections.result_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_resp/1","title":"Spear.Records.Projections.result_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_resp/2","title":"Spear.Records.Projections.result_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Projections.html#service/0","title":"Spear.Records.Projections.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Projections.html#service_module/0","title":"Spear.Records.Projections.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Projections.html#state_req/1","title":"Spear.Records.Projections.state_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req/2","title":"Spear.Records.Projections.state_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req_options/1","title":"Spear.Records.Projections.state_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req_options/2","title":"Spear.Records.Projections.state_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_resp/1","title":"Spear.Records.Projections.state_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_resp/2","title":"Spear.Records.Projections.state_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req/1","title":"Spear.Records.Projections.statistics_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req/2","title":"Spear.Records.Projections.statistics_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req_options/1","title":"Spear.Records.Projections.statistics_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req_options/2","title":"Spear.Records.Projections.statistics_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp/1","title":"Spear.Records.Projections.statistics_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp/2","title":"Spear.Records.Projections.statistics_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp_details/1","title":"Spear.Records.Projections.statistics_resp_details/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp_details/2","title":"Spear.Records.Projections.statistics_resp_details/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req/1","title":"Spear.Records.Projections.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req/2","title":"Spear.Records.Projections.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req_options/1","title":"Spear.Records.Projections.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req_options/2","title":"Spear.Records.Projections.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_resp/1","title":"Spear.Records.Projections.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_resp/2","title":"Spear.Records.Projections.update_resp/2","type":"macro"},{"doc":"Shared record definitions for EventStoreDB messages","ref":"Spear.Records.Shared.html","title":"Spear.Records.Shared","type":"module"},{"doc":"","ref":"Spear.Records.Shared.html#empty/1","title":"Spear.Records.Shared.empty/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#empty/2","title":"Spear.Records.Shared.empty/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Shared.html#service/0","title":"Spear.Records.Shared.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Shared.html#service_module/0","title":"Spear.Records.Shared.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Shared.html#stream_identifier/1","title":"Spear.Records.Shared.stream_identifier/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#stream_identifier/2","title":"Spear.Records.Shared.stream_identifier/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid/1","title":"Spear.Records.Shared.uuid/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid/2","title":"Spear.Records.Shared.uuid/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid_structured/1","title":"Spear.Records.Shared.uuid_structured/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid_structured/2","title":"Spear.Records.Shared.uuid_structured/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Streams API","ref":"Spear.Records.Streams.html","title":"Spear.Records.Streams","type":"module"},{"doc":"","ref":"Spear.Records.Streams.html#append_req/1","title":"Spear.Records.Streams.append_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req/2","title":"Spear.Records.Streams.append_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_options/1","title":"Spear.Records.Streams.append_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_options/2","title":"Spear.Records.Streams.append_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_proposed_message/1","title":"Spear.Records.Streams.append_req_proposed_message/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_proposed_message/2","title":"Spear.Records.Streams.append_req_proposed_message/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp/1","title":"Spear.Records.Streams.append_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp/2","title":"Spear.Records.Streams.append_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_position/1","title":"Spear.Records.Streams.append_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_position/2","title":"Spear.Records.Streams.append_resp_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_success/1","title":"Spear.Records.Streams.append_resp_success/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_success/2","title":"Spear.Records.Streams.append_resp_success/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_wrong_expected_version/1","title":"Spear.Records.Streams.append_resp_wrong_expected_version/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_wrong_expected_version/2","title":"Spear.Records.Streams.append_resp_wrong_expected_version/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req/1","title":"Spear.Records.Streams.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req/2","title":"Spear.Records.Streams.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req_options/1","title":"Spear.Records.Streams.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req_options/2","title":"Spear.Records.Streams.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp/1","title":"Spear.Records.Streams.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp/2","title":"Spear.Records.Streams.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp_position/1","title":"Spear.Records.Streams.delete_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp_position/2","title":"Spear.Records.Streams.delete_resp_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req/1","title":"Spear.Records.Streams.read_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req/2","title":"Spear.Records.Streams.read_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options/1","title":"Spear.Records.Streams.read_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options/2","title":"Spear.Records.Streams.read_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_all_options/1","title":"Spear.Records.Streams.read_req_options_all_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_all_options/2","title":"Spear.Records.Streams.read_req_options_all_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options/1","title":"Spear.Records.Streams.read_req_options_filter_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options/2","title":"Spear.Records.Streams.read_req_options_filter_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options_expression/1","title":"Spear.Records.Streams.read_req_options_filter_options_expression/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options_expression/2","title":"Spear.Records.Streams.read_req_options_filter_options_expression/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_position/1","title":"Spear.Records.Streams.read_req_options_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_position/2","title":"Spear.Records.Streams.read_req_options_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_stream_options/1","title":"Spear.Records.Streams.read_req_options_stream_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_stream_options/2","title":"Spear.Records.Streams.read_req_options_stream_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_subscription_options/1","title":"Spear.Records.Streams.read_req_options_subscription_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_subscription_options/2","title":"Spear.Records.Streams.read_req_options_subscription_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_uuid_option/1","title":"Spear.Records.Streams.read_req_options_uuid_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_uuid_option/2","title":"Spear.Records.Streams.read_req_options_uuid_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp/1","title":"Spear.Records.Streams.read_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp/2","title":"Spear.Records.Streams.read_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_checkpoint/1","title":"Spear.Records.Streams.read_resp_checkpoint/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_checkpoint/2","title":"Spear.Records.Streams.read_resp_checkpoint/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event/1","title":"Spear.Records.Streams.read_resp_read_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event/2","title":"Spear.Records.Streams.read_resp_read_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event_recorded_event/1","title":"Spear.Records.Streams.read_resp_read_event_recorded_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event_recorded_event/2","title":"Spear.Records.Streams.read_resp_read_event_recorded_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_stream_not_found/1","title":"Spear.Records.Streams.read_resp_stream_not_found/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_stream_not_found/2","title":"Spear.Records.Streams.read_resp_stream_not_found/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_subscription_confirmation/1","title":"Spear.Records.Streams.read_resp_subscription_confirmation/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_subscription_confirmation/2","title":"Spear.Records.Streams.read_resp_subscription_confirmation/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Streams.html#service/0","title":"Spear.Records.Streams.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Streams.html#service_module/0","title":"Spear.Records.Streams.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req/1","title":"Spear.Records.Streams.tombstone_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req/2","title":"Spear.Records.Streams.tombstone_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req_options/1","title":"Spear.Records.Streams.tombstone_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req_options/2","title":"Spear.Records.Streams.tombstone_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp/1","title":"Spear.Records.Streams.tombstone_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp/2","title":"Spear.Records.Streams.tombstone_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp_position/1","title":"Spear.Records.Streams.tombstone_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp_position/2","title":"Spear.Records.Streams.tombstone_resp_position/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Users API","ref":"Spear.Records.Users.html","title":"Spear.Records.Users","type":"module"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req/1","title":"Spear.Records.Users.change_password_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req/2","title":"Spear.Records.Users.change_password_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req_options/1","title":"Spear.Records.Users.change_password_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req_options/2","title":"Spear.Records.Users.change_password_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_resp/1","title":"Spear.Records.Users.change_password_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_resp/2","title":"Spear.Records.Users.change_password_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req/1","title":"Spear.Records.Users.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req/2","title":"Spear.Records.Users.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req_options/1","title":"Spear.Records.Users.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req_options/2","title":"Spear.Records.Users.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_resp/1","title":"Spear.Records.Users.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_resp/2","title":"Spear.Records.Users.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req/1","title":"Spear.Records.Users.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req/2","title":"Spear.Records.Users.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req_options/1","title":"Spear.Records.Users.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req_options/2","title":"Spear.Records.Users.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_resp/1","title":"Spear.Records.Users.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_resp/2","title":"Spear.Records.Users.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req/1","title":"Spear.Records.Users.details_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req/2","title":"Spear.Records.Users.details_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req_options/1","title":"Spear.Records.Users.details_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req_options/2","title":"Spear.Records.Users.details_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp/1","title":"Spear.Records.Users.details_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp/2","title":"Spear.Records.Users.details_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details/1","title":"Spear.Records.Users.details_resp_user_details/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details/2","title":"Spear.Records.Users.details_resp_user_details/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details_date_time/1","title":"Spear.Records.Users.details_resp_user_details_date_time/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details_date_time/2","title":"Spear.Records.Users.details_resp_user_details_date_time/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req/1","title":"Spear.Records.Users.disable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req/2","title":"Spear.Records.Users.disable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req_options/1","title":"Spear.Records.Users.disable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req_options/2","title":"Spear.Records.Users.disable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_resp/1","title":"Spear.Records.Users.disable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_resp/2","title":"Spear.Records.Users.disable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req/1","title":"Spear.Records.Users.enable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req/2","title":"Spear.Records.Users.enable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req_options/1","title":"Spear.Records.Users.enable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req_options/2","title":"Spear.Records.Users.enable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_resp/1","title":"Spear.Records.Users.enable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_resp/2","title":"Spear.Records.Users.enable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req/1","title":"Spear.Records.Users.reset_password_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req/2","title":"Spear.Records.Users.reset_password_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req_options/1","title":"Spear.Records.Users.reset_password_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req_options/2","title":"Spear.Records.Users.reset_password_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_resp/1","title":"Spear.Records.Users.reset_password_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_resp/2","title":"Spear.Records.Users.reset_password_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Users.html#service/0","title":"Spear.Records.Users.service/0","type":"function"},{"doc":"Returns the :gpb-generated service module","ref":"Spear.Records.Users.html#service_module/0","title":"Spear.Records.Users.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Users.html#update_req/1","title":"Spear.Records.Users.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req/2","title":"Spear.Records.Users.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req_options/1","title":"Spear.Records.Users.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req_options/2","title":"Spear.Records.Users.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_resp/1","title":"Spear.Records.Users.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_resp/2","title":"Spear.Records.Users.update_resp/2","type":"macro"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedAdded record interface modules for all remaining APIsAdded functions for interacting with the Users APISpear.change_user_password/5Spear.create_user/6Spear.delete_user/3Spear.disable_user/3Spear.enable_user/3Spear.reset_user_password/4Spear.update_user/6Spear.user_details/3associated functions in Spear.Client","ref":"changelog.html#0-3-0-2021-04-18","title":"Changelog - 0.3.0 - 2021-04-18","type":"extras"},{"doc":"AddedWrapped new ACL-related functions in Spear.ClientSpear.Client.get_stream_metadata/2Spear.Client.set_stream_metadata/2Spear.Client.set_global_acl/3","ref":"changelog.html#0-2-1-2021-04-17","title":"Changelog - 0.2.1 - 2021-04-17","type":"extras"},{"doc":"ChangedRefactored connection configuration to go through validation:opts option has been renamed to :mint_optscredentials are passed through the :connection_string option or as :username and :password optionsAddedImplemented and documented keep-aliveThis can be configured through the keepAliveInterval and keepAliveTimeout query params in :connection_string or by the new :keep_alive_interval and :keep_alive_timeout configuration options","ref":"changelog.html#0-2-0-2021-04-17","title":"Changelog - 0.2.0 - 2021-04-17","type":"extras"},{"doc":"Added{:eos, :closed} is now emitted when a subscription is broken due to the connection between closed between Spear.Connection and EventStoreDBSpear.Connection now monitors subscription processes and cancels EventStoreDB subscriptions upon subscriber process exit","ref":"changelog.html#0-1-4-2021-04-16","title":"Changelog - 0.1.4 - 2021-04-16","type":"extras"},{"doc":"AddedAdded documentation and functionality for using TLS certificatessee Spear.Connection and the security guideAdded documentation and functionality for setting the global stream ACLsee Spear.set_global_acl/4 and the Spear.Acl moduleAdded functionality for getting and setting stream-level metadata.Spear.meta_stream/1Spear.get_stream_metadata/3Spear.set_stream_metadata/3Spear.StreamMetadata","ref":"changelog.html#0-1-3-2021-04-15","title":"Changelog - 0.1.3 - 2021-04-15","type":"extras"},{"doc":"AddedAdded dependency on connectionAdded ping functionality for Spear.ConnectionsSpear.ping/1 and Spear.ping/2Spear.Client.ping/0 and Spear.Client.ping/1Added the ability to disconnect a connection by GenServer.call/3ing it with :close as the messageAdded the ability to explicitly reconnect a connection by GenServer.cast/2ing it a message of :connectChangedChanged the internals of Spear.Connection to take advantage of the new Connection dependencyA failure to connect on GenServer init for a connection will no longer take down the supervision treeFailures to connect will result in back-off retries in 500ms segmentsThe life-cycle of the HTTP2 connection spawned by a Spear.Connection is now divorced from the life-cycle of the Spear.Connection process","ref":"changelog.html#0-1-2-2021-04-14","title":"Changelog - 0.1.2 - 2021-04-14","type":"extras"},{"doc":"RemovedRemoved dependency on elixir-protobuf/protobufsee #4also removed all generated files from protobufAddedAdded dependency on :gpband associated generated erlang filesAdded Spear.Records.* interface for interacting with gpb-generated records","ref":"changelog.html#0-1-1-2021-04-14","title":"Changelog - 0.1.1 - 2021-04-14","type":"extras"},{"doc":"AddedInitial implementation of a client for the streams APIall notable functions are labeled with the since: &quot;0.1.0&quot; doc attribute","ref":"changelog.html#0-1-0-2021-04-12","title":"Changelog - 0.1.0 - 2021-04-12","type":"extras"},{"doc":"Writing EventsThis guide covers specifics about the Spear.append/4 function and general information about the event-writing functionality.","ref":"writing_events.html","title":"Writing Events","type":"extras"},{"doc":"event_stream is an Enumerable.t/0 which will be lazily written to the EventStoreDB as elements of the stream are computed and serialized on to the wire.This means a few things:First, you can efficiently emit events from a stream over a large source such as a CSV file with many lines:File.stream!(&quot;large.csv&quot;, read_ahead: 100_000) |&gt; MyCsvParser.parse_stream() |&gt; Stream.map(&amp;MyCsvParser.turn_csv_line_into_spear_event/1) |&gt; Spear.append(conn, &quot;ChargesFromCsvs&quot;, timeout: :infinity) # =&gt; :okThe stream is only fully run after the last bytes have been written to the gRPC network request: the stream is never computed entirely in memory.Second, you may (but are not encouraged to) write events via an infinite stream. A trivial counter mechanism could be implemented like soiex&gt; Stream.iterate(0, &amp;(&amp;1 + 1)) ...&gt; |&gt; Stream.map(fn n -&gt; Spear.Event.new(&quot;incremented&quot;, n) end) ...&gt; |&gt; Spear.append(conn, &quot;InfiniteCounter&quot;, timeout: :infinity, expect: :empty) {:error, %Spear.Grpc.Response{ data: &quot;&quot;, message: &quot;Maximum Append Size of 1048576 Exceeded.&quot;, status: :invalid_argument, status_code: 3 }}Note that while EventStoreDB streams can in theory store infinitely long streams, they are not practically able to do so. EventStoreDB limits the size of a single write to 1_048_576 cumulative bytes. This budget can be spent on one very large event or, as shown above, many tiny events in a single call to Spear.append/4. Attempting to write more than the budget will fail the request with the above signature and no events in the request will be written to the EventStoreDB. This value is configurable in the EventStoreDB configuration.","ref":"writing_events.html#enumeration-characteristics","title":"Writing Events - Enumeration Characteristics","type":"extras"},{"doc":"While Spear.append/4 blocks the caller for the duration of the request, it does not fully block the connection. The connection will write chunks of data over the wire as allowed by HTTP2 window sizes.HTTP2 includes a back-pressure mechanism for clients sending large amounts of data to the server faster than the server can handle. Servers negotiate a maximum number of bytes which the client is allowed to send called a window. When the window has been exhausted by streaming data to the server, the client must wait until the server replenishes the window. During the downtime between exhausting a window and waiting for the server to replenish, Spear suspends the exhausted request stream and handles incoming messages from the server as normal. Since HTTP2 window sizes are relatively small (usually somewhere around the range of 10 and 100 KB), Spear takes conceptual breaks somewhat often during large requests. This allows Spear to efficiently multiplex large writes with large reads and subscriptions.","ref":"writing_events.html#blocking","title":"Writing Events - Blocking","type":"extras"},{"doc":"When appending multiple events, Spear will fit as many messages as possible into the same HTTP2 DATA frame. This is valid according to the gRPC specification and has the potential to improve performance.","ref":"writing_events.html#batching","title":"Writing Events - Batching","type":"extras"},{"doc":"StreamsSpear uses Elixir Streams consistency across its API but there are many conceptual meanings of &quot;stream&quot; in the systems which Spear composes. Consider this call:iex&gt; Spear.stream!(conn, &quot;MyStream&quot;, chunk_size: 20) |&gt; Enum.to_list() [%Spear.Event{}, %Spear.Event{}, ..]This callreads an EventStoreDB streamover an HTTP2 streamwhich is typed as a gRPC stream responseand is collected into an Elixir StreamThere are four significant concepts for streams in Spear:HTTP2 streams of datagRPC stream requests, responses, and bidirectional communicationEventStoreDB streams of eventsElixir StreamsWe'll cover each topic separately to avoid confusion.HTTP2 streamsHTTP2 streams are channels for data and may be multiplexed: multiple requests may stream data in either direction (client to server or server to client) at once. HTTP2 streams (and some GenServer tricks) allow Spear to multiplex requests and subscriptions in a single HTTP2 connection without blocking. Besides concurrency and blocking concerns, HTTP2 streams are mostly an implementation detail in Spear.gRPC streamsgRPC allows &quot;unary&quot; request-responses similar to a REST request-response over HTTP. This resembles synchronous function (or GenServer) calls. The true power of gRPC, though, comes from its ability to &quot;stream&quot; requests, responses, or requests and responses simultaneously. Consider this RPC definition from the EventStoreDB gRPC protobufs:rpc Read (ReadReq) returns (stream ReadResp);In the Spear.stream!/3 function, this &quot;stream&quot; response lends itself to an Elixir Stream. Conceptually the ReadResp messages are returned as an ordered list of events in an EventStoreDB stream. These response messages are returned as quickly as possible and resemble a unary request very closely.This same RPC is invoked to implement Spear.subscribe/4, though, which does not return an Elixir Enumerable.t/0. Instead this function asynchronously signs-up the given process for receiving messages per event.gRPC streams may emulate synchronous calls returning lists as with Spear.stream!/3 but are also commonly used to implement asynchronous subscription workflows as with Spear.subscribe/4.gRPC streams may even be fully asynchronous is both directions as with EventStoreDB Persistent Subscriptions. This communication is known as bidirectional or &quot;bidi-stream&quot; and is covered more fully in the Spear.PersistentSubscription moduledoc.gRPC streams are also an implementation-level detail in Spear and will not be mentioned otherwise in this documentation unless specifically called a &quot;gRPC stream&quot;.EventStoreDB streamsEventStoreDB streams are append-only collections of events ordered by the timestamp of each event's commit (or commit preparation). Streams can be read forwards or backwards and from any revision (a fancy way of saying &quot;position in a stream&quot;).EventStoreDB streams will be referred to in this documentation as EventStoreDB streams, or simply &quot;streams&quot; where contextually appropriate.Elixir StreamsElixir Streams are conceptually different than both gRPC/HTTP2 streams and EventStoreDB streams. Elixir Streams differ as well from lazy enumerables in other languages like Haskell due to the lack of a &quot;thunk&quot; built-in. Streams are simply formulas for producing enumerable collections such as Lists.Since streams are a formula and not an actual list (or otherwise collectable), they can exploit some lovely properties:computations can be done lazily on demandthis can reduce memory consumptionstreams can be composedstreams can be infiniteA common example is reading a large file such as a big CSV. Without streams, the entire file must be read into memory and each transformation of each line or chunk must be computed in entirety before moving on to the next operation (e.g. with Enum.map/2 or Enum.reduce/3). With a file stream, one may read a large file line-by-line, perform many Stream.map/2s (or similar) and eventually perform some side-effect by forcing the stream with Stream.run/1 or an Enum function. Only once the first line or chunk has been read from the file and run through the pipeline of composed stream functions will the next one be read and run through.To differentiate, we will most commonly refer to Elixir Streams in the Spear documentation by their canonical data-type: Enumerable.t/0.","ref":"streams.html","title":"Streams","type":"extras"},{"doc":"Link ResolutionSome functions in Spear have :resolve_links? options. Projected streams such as streams beginning with &quot;$&quot; or custom-made projected streams do not copy event bodies literally from linked events. For example, the &quot;$all&quot; projected stream does not contain a copy of every event in the eventstore. Rather projected streams are comprised of link events which are very slim references to the source events. This is conceptually similar to pointers in a language like C.When we read a projected stream (in this example an event-type stream) with :resolve_links? set to false, we seeiex&gt; import Spear.Records.Streams iex&gt; alias Spear.Protos.EventStoreDB.Client.Streams.ReadResp iex&gt; Spear.stream!(conn, &quot;$et-grpc-client&quot;, chunk_size: 1, resolve_links?: false, raw?: true) |&gt; Enum.take(1) [ read_resp( content: {:event, read_resp_read_event( event: read_resp_read_event_recorded_event( data: &quot;0@es_supported_clients&quot; ), link: :undefined ) ) ) ](Note that the read-response bodies we see in this section are simplified to only show the parts interesting to link resolution.)The link field on the read event is nil and the event field has a strange data body of 0@es_supported_clients. With link resolution turned off, we are telling the EventStoreDB that we'd like to read the stream literally: to receive just the links themselves.When we turn link resolution on, we see a different pictureiex&gt; import Spear.Records.Streams iex&gt; Spear.stream!(conn, &quot;$et-grpc-client&quot;, chunk_size: 1, resolve_links?: true, raw?: true) |&gt; Enum.take(1) [ read_resp( content: {:event, read_resp_read_event( event: read_resp_read_event_recorded_event( data: &quot;{\\&quot;languages\\&quot;:[\\&quot;typescript\\&quot;,\\&quot;javascript\\&quot;],\\&quot;runtime\\&quot;:\\&quot;NodeJS\\&quot;}&quot;, ), link: read_resp_read_event_recorded_event( data: &quot;0@es_supported_clients&quot;, ) )) ) ]Now the :link field contains the reference to the original event and the :event contains the full data for the original event.What happens if you try to resolve links for an EventStoreDB stream which is not a projected stream?iex&gt; import Spear.Records.Streams iex&gt; Spear.stream!(conn, &quot;es_supported_clients&quot;, chunk_size: 1, resolve_links?: true, raw?: true) |&gt; Enum.take(1) [ read_resp( content: {:event, read_resp_read_event( event: read_resp_read_event_recorded_event( data: &quot;{\\&quot;languages\\&quot;:[\\&quot;typescript\\&quot;,\\&quot;javascript\\&quot;],\\&quot;runtime\\&quot;:\\&quot;NodeJS\\&quot;}&quot;, ), link: :undefined )) ) ]Nothing! The events from non-projected streams are unaffected by link resolution choice. Hence the :resolve_links? option is consistently defaulted to true.","ref":"link_resolution.html","title":"Link Resolution","type":"extras"},{"doc":"SecurityEventStoreDB has a few options for security which are now all enabled by default in EventStoreDB 20+:connections over TLS (SSL/HTTPS)username+password basic-auth credentialsaccess control lists (ACLs) on streams or globally to an EventStoreDBBy default in EventStoreDB 20+, these are all enabled. The EventStoreDB may be run with the --insecure command line flag to disable all of them together.","ref":"security.html","title":"Security","type":"extras"},{"doc":"The EventStore documentation now includes a helpful configuration wizard which will help set up custom or cloud installations of EventStoreDB with the proper networking, config, clustering, and certificates. For any production use-case, see the EventStore documentation.The repository for Spear includes a certs/ directory with some generated certificates. Note that the private keys are included in the repository, so the certificates in that directory are not suitable for any real-world case. Please only use them on a local machine not connected to the internet.Assuming that you're running a Linux machine with the eventstore-oss package installed, we can install the certificates in this repository like so. Note that these commands will probably need to be run through sudo.$ cd /path/to/spear $ mkdir -p /etc/eventstore/certs $ cp -r ./certs/ca /etc/eventstore/certs/ $ cp ./certs/node1/* /etc/eventstore/certs $ cp ./certs/eventstore.conf /etc/eventstore/ $ chown -R eventstore /etc/eventstore/ $ chgrp -R eventstore /etc/eventstore/ $ systemctl restart eventstoreNow the EventStoreDB should be set up to force TLS connections. You may need to edit the existing service description to remove the --insecure flag if present.","ref":"security.html#setting-up-an-eventstoredb-for-security","title":"Security - Setting up an EventStoreDB for security","type":"extras"},{"doc":"A Spear.Connection takes an :opts option which is passed to Mint.HTTP.connect/4. We can inform mint of our custom ./certs/ca/ca.crt CA certificate like so:connection_config = [ connection_string: &quot;esdb://localhost:2113?tls=true&quot;, opts: [ transport_opts: [ cacertfile: Path.join([__DIR__ | ~w(certs ca ca.crt)]) ] ] ] # as a supervisor spec: {Spear.Connection, connection_config} # or as a direct call of start_link iex&gt; {:ok, conn} = Spear.Connection.start_link(connection_config)Note that this same configuration works with a Spear.Client with this configuration in application-config (config/*.exs).If you're following along with the guide and have set up an EventStoreDB with the certificates from the certs/ directory in the spear repository, you should now be able to spawn a connection which will force a TLS connection.","ref":"security.html#using-custom-tls-certificates-with-spear","title":"Security - Using custom TLS certificates with Spear","type":"extras"},{"doc":"Certificates signed by a public certificate authority (CA) such as the Domain Validation (DV) certificates produced by the wonderful Letsencrypt project should work out-of-the-box if the castore dependency is included in your project.# mix.exs .. def deps do [ {:spear, &quot;~&gt; 0.1&quot;}, {:castore, &quot;&gt;= 0.0.0&quot;} ] end ..With castore, you should not need to pass any transport_opts to Mint.connection_config = [ connection_string: &quot;esdb://localhost:2113?tls=true&quot; ]","ref":"security.html#using-tls-certificates-signed-by-a-public-ca","title":"Security - Using TLS certificates signed by a public CA","type":"extras"},{"doc":"Now that TLS is enabled, we can safely pass basic-auth credentials over the network. Spear.Connection accepts a :credentials option as a two-tuple of {username, password}. E.g. with the default login credentials, a connection can be configured like so:connection_config = [ connection_string: &quot;esdb://localhost:2113?tls=true&quot;, credentials: {&quot;admin&quot;, &quot;changeit&quot;}, opts: [ transport_opts: [ cacertfile: Path.join([__DIR__ | ~w(certs ca ca.crt)]) ] ] ]Credentials can also be passed on a per-request basis for all core Spear functions (except Spear.ping/2; pings do not require/allow authentication as they are not actual requests). All core functions allow a :credentials option two-tuple of {username, password} which override the connection-level credentials if provided.E.g. reading a stream as a user named &quot;Aladdin&quot; (assuming such a user exists):# say we use `connection_config` from above: the connection has credentials # of {&quot;admin&quot;, &quot;changeit&quot;} iex&gt; {:ok, conn} = Spear.Connection.start_link(connection_config) # the :credentials option overrides the connection-level credentials iex&gt; Spear.stream!(conn, &quot;my_stream&quot;, credentials: {&quot;Aladdin&quot;, &quot;open sesame&quot;}) |&gt; Enum.take(1) [%Spear.Event{}]","ref":"security.html#credentials","title":"Security - Credentials","type":"extras"},{"doc":"Now that we know how to operate the client as a user, how does EventStoreDB use credentials to allow or deny access to resources?EventStoreDB uses access control lists (ACLs) to allow or deny access to various operations per user or group.ACLs (like virtually everything in EventStoreDB) are just events in a stream. A simple ACL event body might look like{ &quot;$acl&quot;: { &quot;$w&quot;: &quot;$admins&quot;, &quot;$r&quot;: &quot;$all&quot;, &quot;$d&quot;: &quot;$admins&quot;, &quot;$mw&quot;: &quot;$admins&quot;, &quot;$mr&quot;: &quot;$admins&quot; } }What do each of these mean?valueresource$wwrite events to this stream$rread events from this stream$ddelete this stream$mwwrite metadata associated with this stream$mrread metadata associated with this stream$adminsthe group of admin users$allall users (including anonymous users)Note that the ACL is controlled by writing stream metadata, so the $mw permission allows a user to change the ACL of a stream.The global ACLThe $streams system stream may be used to change the default ACL applied to all streams. By default, the global ACL is{ &quot;$userStreamAcl&quot;: { &quot;$r&quot;: &quot;$all&quot;, &quot;$w&quot;: &quot;$all&quot;, &quot;$d&quot;: &quot;$all&quot;, &quot;$mr&quot;: &quot;$all&quot;, &quot;$mw&quot;: &quot;$all&quot; }, &quot;$systemStreamAcl&quot;: { &quot;$r&quot;: &quot;$admins&quot;, &quot;$w&quot;: &quot;$admins&quot;, &quot;$d&quot;: &quot;$admins&quot;, &quot;$mr&quot;: &quot;$admins&quot;, &quot;$mw&quot;: &quot;$admins&quot; } }Where $systemStreamAcl applies to projected and otherwise system-created streams and $userStreamAcl applies to all other (user-created) streams.This default is quite permissive: any user including clients that do not supply any credentials can read and write events to user-streams with the default ACL.The global ACL can be changed by writing an event of type update-default-acl with a content type of application/vnd.eventstore.events+json with the above body to the $streams system stream.Spear provides the Spear.Acl struct and Spear.set_global_acl/4 function to set this without dealing with the nitty-gritty details of the structure of that event.Attempting to access a resource with incorrect or invalid credentials will yield an HTTP 401 error.iex&gt; Spear.set_global_acl(conn, Spear.Acl.admins_only(), Spear.Acl.admins_only()) :ok iex&gt; Spear.append([my_event], conn, &quot;some_stream&quot;, credentials: {&quot;no one&quot;, &quot;no pass&quot;}) {:error, %Spear.Grpc.Response{ data: &quot;&quot;, message: &quot;Bad HTTP status code: 401, should be 200&quot;, status: :unknown, status_code: 2 }}Attempting to access a resource with no credentials will yield a gRPC error with a status of :permission_denied.Stream-level ACLsEventStoreDB also allows more fine-grained stream-level ACLs to be defined on a per-stream basis. See the Spear.set_stream_metadata/4 function for an example of setting a stream-level ACL.","ref":"security.html#access-control-lists","title":"Security - Access control lists","type":"extras"}]